<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['cid'])) {
  $cid = abs(intval($_GET['cid']));
} else {
  $cid = 0;
} 
if (isset($_GET['id'])) {
  $id = abs(intval($_GET['id']));
} else {
  $id = 0;
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 
if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 

show_title('down.png', 'Загрузки');

switch ($act):
# ###########################################################################################
# #                                    Главная страница                                    ##
# ###########################################################################################
case 'index':
  $querydown = DB :: $dbh -> query("SELECT * FROM `cats` WHERE `cats_id`=? LIMIT 1;", array($cid));
  $cats = $querydown -> fetch();

  if ($cats > 0) {
    $config['newtitle'] = $cats['cats_name'];

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> <a href="index.php?' . SID . '">Категории</a> / ';

    if (!empty($cats['cats_parent'])) {
      $querycats = DB :: $dbh -> query("SELECT `cats_id`, `cats_name` FROM `cats` WHERE `cats_id`=? LIMIT 1;", array($cats['cats_parent']));
      $podcats = $querycats -> fetch();
      echo '<a href="down.php?cid=' . $podcats['cats_id'] . '&amp;' . SID . '">' . $podcats['cats_name'] . '</a> / ';
    } 

    echo '<a href="add.php?cid=' . $cid . '&amp;' . SID . '">Добавить файл</a><br /><br />';

    echo '<img src="../images/img/open_dir.gif" alt="image" /> <b>' . $cats['cats_name'] . '</b> (Файлов: ' . $cats['cats_count'] . ')';

    if (is_admin(array(101, 102))) {
      echo ' (<a href="' . ADMINDIR . 'load.php?act=down&amp;cid=' . $cid . '&amp;start=' . $start . '&amp;' . SID . '">Управление</a>)';
    } 
    echo '<hr />';

    $querysub = DB :: $dbh -> query("SELECT * FROM `cats` WHERE `cats_parent`=?;", array($cid));
    $sub = $querysub -> fetchAll();

    if (count($sub) > 0 && $start == 0) {
      foreach($sub as $subdata) {
        echo '<div class="b"><img src="../images/img/dir.gif" alt="image" /> ';
        echo '<b><a href="down.php?cid=' . $subdata['cats_id'] . '&amp;' . SID . '">' . $subdata['cats_name'] . '</a></b> (' . $subdata['cats_count'] . ')</div>';
      } 
      echo '<hr />';
    } 

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `downs` WHERE `downs_cats_id`=?;", array($cid));

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $querydown = DB :: $dbh -> query("SELECT * FROM `downs` WHERE `downs_cats_id`=? ORDER BY `downs_time` DESC LIMIT " . $start . ", " . $config['downlist'] . ";", array($cid));

      while ($data = $querydown -> fetch()) {
        echo '<div class="b">';

        echo '<img src="../images/img/zip.gif" alt="image" /> ';

        echo '<b><a href="down.php?act=view&amp;id=' . $data['downs_id'] . '&amp;' . SID . '">' . $data['downs_title'] . '</a></b> (' . read_file('files/' . $data['downs_link']) . ')</div>';

        echo '<div>';

        echo 'Скачиваний: ' . $data['downs_load'] . '<br />';

        $raiting = (!empty($data['downs_rated'])) ? round($data['downs_raiting'] / $data['downs_rated'], 1) : 0;

        echo 'Рейтинг: <b>' . $raiting . '</b> (Голосов: ' . $data['downs_rated'] . ')<br />';
        echo '<a href="down.php?act=comments&amp;id=' . $data['downs_id'] . '&amp;' . SID . '">Комментарии</a> (' . $data['downs_comments'] . ') ';
        echo '<a href="down.php?act=end&amp;id=' . $data['downs_id'] . '&amp;' . SID . '">&raquo;</a></div>';
      } 

      page_strnavigation('down.php?cid=' . $cid . '&amp;', $config['downlist'], $start, $total);
    } else {
      show_error('В данном разделе еще нет файлов!');
    } 
  } else {
    show_error('Ошибка! Данного раздела не существует!');
  } 

  echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
  echo '<a href="top.php?' . SID . '">Топ файлов</a> / ';
  echo '<a href="search.php?' . SID . '">Поиск</a> / ';
  echo '<a href="add.php?cid=' . $cid . '&amp;' . SID . '">Добавить файл</a><br />';
  break;
# ###########################################################################################
# #                                    Просмотр файла                                      ##
# ###########################################################################################
case 'view':

  $downs = DB :: $dbh -> queryFetch("SELECT `downs`.*, `cats`.* FROM `downs` LEFT JOIN `cats` ON `downs`.`downs_cats_id`=`cats`.`cats_id` WHERE `downs_id`=? LIMIT 1;", array($id));

  if ($downs > 0) {
    $config['newtitle'] = $downs['downs_title'];
    $config['description'] = strip_str($downs['downs_text']);

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> <a href="index.php?' . SID . '">Категории</a> / ';

    if (!empty($downs['cats_parent'])) {
      $podcats = DB :: $dbh -> queryFetch("SELECT `cats_id`, `cats_name` FROM `cats` WHERE `cats_id`=? LIMIT 1;", array($downs['cats_parent']));
      echo '<a href="down.php?cid=' . $podcats['cats_id'] . '&amp;' . SID . '">' . $podcats['cats_name'] . '</a> / ';
    } 

    echo '<a href="down.php?cid=' . $downs['cats_id'] . '&amp;' . SID . '">' . $downs['cats_name'] . '</a> / <a href="rss.php?id=' . $id . '&amp;' . SID . '">RSS-лента</a><br /><br />';

    $filesize = read_file('files/' . $downs['downs_link']);
    echo '<img src="../images/img/zip.gif" alt="image" /> <b>' . $downs['downs_title'] . '</b> (' . $filesize . ')';

    if (is_admin(array(101, 102))) {
      echo ' (<a href="' . ADMINDIR . 'load.php?act=editdown&amp;cid=' . $downs['cats_id'] . '&amp;id=' . $id . '&amp;' . SID . '">Редактировать</a>)';
    } 
    echo '<hr />';
    $ext = strrchr($downs['downs_link'], '.');

    if ($ext == '.jpg' || $ext == '.jpeg' || $ext == '.gif' || $ext == '.png') {
      echo '<a href="' . BASEDIR . 'load/files/' . $downs['downs_link'] . '"><img src="' . BASEDIR . 'gallery/resize.php?dir=load/files&amp;name=' . $downs['downs_link'] . '" alt="' . $downs['downs_title'] . '" /></a><br />';
    } 

    echo bb_code($downs['downs_text']) . '<br /><br />';

    if (!empty($downs['downs_screen']) && file_exists(BASEDIR . 'load/screen/' . $downs['downs_screen'])) {
      echo 'Скриншот:<br />';

      echo '<a href="screen/' . $downs['downs_screen'] . '">';
      echo '<img src="../gallery/resize.php?dir=load/screen&amp;name=' . $downs['downs_screen'] . '" alt="image" /></a><br /><br />';
    } 

    if (!empty($downs['downs_author'])) {
      echo 'Автор файла: ' . $downs['downs_author'];

      if (!empty($downs['downs_site'])) {
        echo ' (<a href="' . $downs['downs_site'] . '">' . $downs['downs_site'] . '</a>)';
      } 
      echo '<br />';
    } 

    if (!empty($downs['downs_site']) && empty($downs['downs_author'])) {
      echo 'Сайт автора: <a href="' . $downs['downs_site'] . '">' . $downs['downs_site'] . '</a><br />';
    } 

    echo 'Добавлено: <a href="../pages/anketa.php?uz=' . $downs['downs_user'] . '&amp;' . SID . '">' . nickname($downs['downs_user']) . '</a> (' . date_fixed($downs['downs_time']) . ')<hr />';
    // -----------------------------------------------------------//
    if (!empty($downs['downs_link']) && file_exists(BASEDIR . 'load/files/' . $downs['downs_link'])) {
      if (is_user()) {
        echo '<img src="../images/img/download.gif" alt="image" /> <b><a href="down.php?act=load&amp;id=' . $id . '&amp;' . SID . '">Скачать</a></b>  (' . $filesize . ')<br />';
      } else {
        echo '<div class="form">';
        echo '<form action="down.php?act=load&amp;id=' . $id . '&amp;' . SID . '" method="post">';

        echo 'Проверочный код: ';
        echo '<img src="../gallery/protect.php?' . SID . '" alt="" /> <br />';
        echo '<input name="provkod" size="6" maxlength="6" />';
        echo '<input type="submit" value="Скачать" /></form>';
        echo '<em>Чтобы не вводить код при каждом скачивании, советуем зарегистрироваться</em></div><br />';
      } 

      if ($ext == '.zip') {
        echo '<img src="../images/img/zip.gif" alt="image" /> <b><a href="zip.php?id=' . $id . '&amp;' . SID . '">Просмотреть архив</a></b><br />';
      } 

      echo '<img src="../images/img/balloon.gif" alt="image" /> <b><a href="down.php?act=comments&amp;id=' . $id . '&amp;' . SID . '">Комментарии</a></b> (' . $downs['downs_comments'] . ') ';
      echo '<a href="down.php?act=end&amp;id=' . $id . '&amp;' . SID . '">&raquo;</a><br />';

      $raiting = (!empty($downs['downs_rated'])) ? round($downs['downs_raiting'] / $downs['downs_rated'], 1) : 0;
      echo '<br />Рейтинг: ' . raiting_vote($raiting) . '<br />';
      echo 'Всего голосов: <b>' . $downs['downs_rated'] . '</b><br /><br />';

      if (is_user()) {
        echo '<form action="down.php?act=vote&amp;id=' . $id . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo '<select name="score">';
        echo '<option value="5">Отлично</option>';
        echo '<option value="4">Хорошо</option>';
        echo '<option value="3">Нормально</option>';
        echo '<option value="2">Плохо</option>';
        echo '<option value="1">Отстой</option>';
        echo '</select>';
        echo '<input type="submit" value="Oценить" /></form>';
      } 

      echo 'Всего скачиваний: <b>' . $downs['downs_load'] . '</b><br />';
      if (!empty($downs['downs_last_load'])) {
        echo 'Последнее скачивание: ' . date_fixed($downs['downs_last_load'], 'j F Y / H:i') . '<br />';
      } 

      if (is_user()) {
        echo '<br />Скопировать адрес:<br />';
        echo '<input name="text" size="40" value="' . $config['home'] . '/load/files/' . $downs['downs_link'] . '" /><br /><br />';

        echo 'BB-код для форума:<br />';
        echo '<input name="text" size="40" value="[url=' . $config['home'] . '/load/down.php?act=view&amp;id=' . $id . ']' . $downs['downs_title'] . '[/url]" /><br />';
      } 

      echo '<br />';
    } else {
      show_error('Файл еще не загружен!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?cid=' . $downs['cats_id'] . '&amp;' . SID . '">' . $downs['cats_name'] . '</a><br />';
  } else {
    show_error('Ошибка! Данного файла не существует!');
  } 
  break;
# ###########################################################################################
# #                                     Скачивание файла                                   ##
# ###########################################################################################
case 'load':

  if (isset($_POST['provkod'])) {
    $provkod = abs(intval($_POST['provkod']));
  } 

  if (is_user() || $provkod == $_SESSION['protect']) {
    $querydown = DB :: $dbh -> query("SELECT * FROM downs WHERE downs_id=? LIMIT 1;", array($id));
    $downs = $querydown -> fetch();

    if ($downs > 0) {
      if (file_exists('files/' . $downs['downs_link'])) {
        $queryloads = DB :: $dbh -> querySingle("SELECT loads_ip FROM loads WHERE loads_down=? AND loads_ip=? LIMIT 1;", array($id, $ip));
        if (empty($queryloads)) {
          $expiresloads = SITETIME + 3600 * $config['expiresloads'];

          DB :: $dbh -> query("DELETE FROM loads WHERE loads_time<?;", array(SITETIME));
          DB :: $dbh -> query("INSERT INTO loads (loads_down, loads_ip, loads_time) VALUES (?, ?, ?);", array($id, $ip, $expiresloads));
          DB :: $dbh -> query("UPDATE downs SET downs_load=downs_load+1, downs_last_load=? WHERE downs_id=?", array(SITETIME, $id));
        } 

        unset($_SESSION['protect']);
        header("location: files/" . $downs['downs_link']);
        exit;
      } else {
        show_error('Ошибка! Файла для скачивания не существует!');
      } 
    } else {
      show_error('Ошибка! Данного файла не существует!');
    } 
  } else {
    show_error('Ошибка! Проверочное число не совпало с данными на картинке!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=view&amp;id=' . $id . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                       Оценка файла                                     ##
# ###########################################################################################
case 'vote':

  $uid = check($_GET['uid']);
  if (isset($_POST['score'])) {
    $score = abs(intval($_POST['score']));
  } else {
    $score = 0;
  } 

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if ($score > 0 && $score <= 5) {
        $querydown = DB :: $dbh -> query("SELECT * FROM `downs` WHERE `downs_id`=? LIMIT 1;", array($id));
        $downs = $querydown -> fetch();

        if (!empty($downs)) {
          if ($log != $downs['downs_user']) {
            $queryrated = DB :: $dbh -> querySingle("SELECT `rated_id` FROM `rateddown` WHERE `rated_down`=? AND `rated_user`=? LIMIT 1;", array($id, $log));

            if (empty($queryrated)) {
              $expiresrated = SITETIME + 3600 * $config['expiresrated'];

              DB :: $dbh -> query("DELETE FROM `rateddown` WHERE `rated_time`<?;", array(SITETIME));
              DB :: $dbh -> query("INSERT INTO `rateddown` (`rated_down`, `rated_user`, `rated_time`) VALUES (?, ?, ?);", array($id, $log, $expiresrated));
              DB :: $dbh -> query("UPDATE `downs` SET `downs_raiting`=`downs_raiting`+?, `downs_rated`=`downs_rated`+1 WHERE `downs_id`=?", array($score, $id));

              echo '<b>Спасибо! Ваша оценка "' . $score . '" принята!</b><br />';
              echo 'Всего оценивало: ' . ($downs['downs_rated'] + 1) . '<br />';
              echo 'Средняя оценка: ' . round(($downs['downs_raiting'] + $score) / ($downs['downs_rated'] + 1), 1) . '<br /><br />';
            } else {
              show_error('Ошибка! Вы уже оценивали данный файл!');
            } 
          } else {
            show_error('Ошибка! Нельзя голосовать за свой файл!');
          } 
        } else {
          show_error('Ошибка! Данного файла не существует!');
        } 
      } else {
        show_error('Ошибка! Необходимо поставить оценку от 1 до 5 включительно!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, для голосования за файлы, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=view&amp;id=' . $id . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                        Комментарии                                     ##
# ###########################################################################################
case 'comments':

  $querydown = DB :: $dbh -> query("SELECT * FROM `downs` WHERE `downs_id`=? LIMIT 1;", array($id));
  $downs = $querydown -> fetch();

  if (!empty($downs)) {
    $config['newtitle'] = 'Комментарии - ' . $downs['downs_title'];

    echo '<img src="../images/img/zip.gif" alt="image" /> <b><a href="down.php?act=view&amp;id=' . $id . '&amp;' . SID . '">' . $downs['downs_title'] . '</a></b><br /><br />';

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
    echo '<a href="down.php?act=comments&amp;id=' . $id . '&amp;rand=' . mt_rand(100, 999) . '&amp;' . SID . '">Обновить</a> / <a href="rss.php?id=' . $id . '&amp;' . SID . '">RSS-лента</a><hr />';

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `commload` WHERE `commload_down`=?;", array($id));

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $is_admin = is_admin(array(101, 102, 103, 105));
      if ($is_admin) {
        echo '<form action="down.php?act=del&amp;id=' . $id . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      } 

      $querycomm = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_down`=? ORDER BY `commload_time` ASC LIMIT " . $start . ", " . $config['downcomm'] . ";", array($id));

      while ($data = $querycomm -> fetch()) {
        echo '<div class="b">';
        echo '<div class="img">';

        if ($is_admin) {
          echo '<input type="checkbox" name="del[]" value="' . $data['commload_id'] . '" /> ';
        } 

        echo user_avatars($data['commload_author']) . '</div>';

        echo '<b><a href="../pages/anketa.php?uz=' . $data['commload_author'] . '&amp;' . SID . '">' . nickname($data['commload_author']) . '</a></b>';
        echo ' <small>(' . date_fixed($data['commload_time']) . ')</small><br />';
        echo user_title($data['commload_author']) . ' ' . user_online($data['commload_author']) . '</div>';

        if (!empty($log) && $log != $data['commload_author']) {
          echo '<div class="right">';
          echo '<a href="down.php?act=reply&amp;id=' . $id . '&amp;pid=' . $data['commload_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Отв</a> / ';
          echo '<a href="down.php?act=quote&amp;id=' . $id . '&amp;pid=' . $data['commload_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Цит</a> / ';
          echo '<a href="down.php?act=spam&amp;id=' . $id . '&amp;pid=' . $data['commload_id'] . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" onclick="return confirm(\'Вы подтверждаете факт спама?\')">Спам</a></div>';
        } 

        if ($log == $data['commload_author'] && $data['commload_time'] + 600 > SITETIME) {
          echo '<div class="right"><a href="down.php?act=edit&amp;id=' . $id . '&amp;pid=' . $data['commload_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a></div>';
        } 

        echo '<div>' . bb_code($data['commload_text']) . '<br />';

        if (is_admin() || empty($config['anonymity'])) {
          echo '<span class="data">(' . $data['commload_brow'] . ', ' . $data['commload_ip'] . ')</span>';
        } 
        echo '</div>';
      } 

      if ($is_admin) {
        echo '<br /><input type="submit" value="Удалить выбранное" /></form>';
      } 

      page_strnavigation('down.php?act=comments&amp;id=' . $id . '&amp;', $config['downcomm'], $start, $total);
    } else {
      show_error('Комментариев еще нет!');
    } 

    if (is_user()) {
      echo '<div class="form">';
      echo '<form action="down.php?act=add&amp;id=' . $id . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo '<b>Сообщение:</b><br />';
      echo '<textarea cols="25" rows="3" name="msg"></textarea><br />';
      echo '<input type="submit" value="Написать" /></form></div><br />';

      echo '<a href="#up"><img src="../images/img/ups.gif" alt="image" /></a> ';
      echo '<a href="../pages/rules.php?' . SID . '">Правила</a> / ';
      echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a> / ';
      echo '<a href="../pages/tegi.php?' . SID . '">Теги</a><br /><br />';
    } else {
      show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
    } 
  } else {
    show_error('Ошибка! Данного файла не существует!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=view&amp;id=' . $id . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                Добавление комментариев                                 ##
# ###########################################################################################
case 'add':

  $uid = check($_GET['uid']);
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1000) {
        $querydown = DB :: $dbh -> querySingle("SELECT `downs_cats_id` FROM `downs` WHERE `downs_id`=? LIMIT 1;", array($id));

        if (!empty($querydown)) {
          if (is_quarantine($log)) {
            if (is_flood($log)) {
              $msg = no_br($msg);
              $msg = antimat($msg);
              $msg = smiles($msg);

              DB :: $dbh -> query("INSERT INTO `commload` (`commload_cats`, `commload_down`, `commload_text`, `commload_author`, `commload_time`, `commload_ip`, `commload_brow`) VALUES (?, ?, ?, ?, ?, ?, ?);", array($querydown, $id, $msg, $log, SITETIME, $ip, $brow));

              DB :: $dbh -> query("DELETE FROM `commload` WHERE `commload_down`=? AND `commload_time` < (SELECT MIN(`commload_time`) FROM (SELECT `commload_time` FROM `commload` WHERE `commload_down`=? ORDER BY `commload_time` DESC LIMIT " . $config['maxdowncomm'] . ") AS del);", array($id, $id));

              DB :: $dbh -> query("UPDATE `downs` SET `downs_comments`=`downs_comments`+1 WHERE `downs_id`=?;", array($id));
              DB :: $dbh -> query("UPDATE `users` SET `users_allcomments`=`users_allcomments`+1, `users_point`=`users_point`+1, `users_money`=`users_money`+5 WHERE `users_login`=?", array($log));

              $_SESSION['note'] = 'Сообщение успешно добавлено!';
              header ("Location: down.php?act=end&id=$id&" . SID);
              exit;
            } else {
              show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
            } 
          } else {
            show_error('Карантин! Вы не можете писать в течении ' . round($config['karantin'] / 3600) . ' часов!');
          } 
        } else {
          show_error('Ошибка! Данного файла не существует!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Жалоба на спам                                      ##
# ###########################################################################################
case 'spam':

  $uid = check($_GET['uid']);
  $pid = abs(intval($_GET['pid']));

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      $querydown = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_id`=? LIMIT 1;", array($pid));
      $data = $querydown -> fetch();

      if (!empty($data)) {
        $queryspam = DB :: $dbh -> querySingle("SELECT `spam_id` FROM `spam` WHERE `spam_key`=? AND `spam_idnum`=? LIMIT 1;", array(5, $pid));

        if (empty($queryspam)) {
          if (is_flood($log)) {
            DB :: $dbh -> query("INSERT INTO `spam` (`spam_key`, `spam_idnum`, `spam_user`, `spam_login`, `spam_text`, `spam_time`, `spam_addtime`, `spam_link`) VALUES (?, ?, ?, ?, ?, ?, ?, ?);", array(5, $data['commload_id'], $log, $data['commload_author'], $data['commload_text'], $data['commload_time'], SITETIME, $config['home'] . '/load/down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start));

            $_SESSION['note'] = 'Жалоба успешно отправлена!';
            header ("Location: down.php?act=comments&id=$id&start=$start&" . SID);
            exit;
          } else {
            show_error('Антифлуд! Разрешается жаловаться на спам не чаще чем раз в ' . flood_period() . ' секунд!');
          } 
        } else {
          show_error('Ошибка! Жалоба на данное сообщение уже отправлена!');
        } 
      } else {
        show_error('Ошибка! Выбранное вами сообщение для жалобы не существует!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы подать жалобу, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Ответ на сообщение                                   ##
# ###########################################################################################
case 'reply':

  $pid = abs(intval($_GET['pid']));

  echo '<b><big>Ответ на сообщение</big></b><br /><br />';

  if (is_user()) {
    $querydown = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_id`=? LIMIT 1;", array($pid));
    $post = $querydown -> fetch();

    if (!empty($post)) {
      echo '<div class="b"><img src="../images/img/edit.gif" alt="image" /> <b><a href="../pages/anketa.php?uz=' . $post['commload_author'] . '&amp;' . SID . '">' . nickname($post['commload_author']) . '</a></b> ' . user_title($post['commload_author']) . ' ' . user_online($post['commload_author']) . ' <small>(' . date_fixed($post['commload_time']) . ')</small></div>';
      echo '<div>Сообщение: ' . bb_code($post['commload_text']) . '</div><hr />';

      echo '<div class="form" id="form">';
      echo '<form action="down.php?act=add&amp;id=' . $id . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[b]' . nickname($post['commload_author']) . '[/b], </textarea><br />';
      echo '<input type="submit" value="Ответить" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для ответа не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы отвечать на сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                   Цитирование сообщения                                ##
# ###########################################################################################
case 'quote':

  $pid = abs(intval($_GET['pid']));

  echo '<b><big>Цитирование</big></b><br /><br />';
  if (is_user()) {
    $querydown = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_id`=? LIMIT 1;", array($pid));
    $post = $querydown -> fetch();

    if (!empty($post)) {
      $post['commload_text'] = nosmiles($post['commload_text']);
      $post['commload_text'] = preg_replace('|\[q\](.*?)\[/q\](<br />)?|', '', $post['commload_text']);
      $post['commload_text'] = str_replace('<br />', "\r\n", $post['commload_text']);

      echo '<div class="form" id="form">';
      echo '<form action="down.php?act=add&amp;id=' . $id . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">[q][b]' . nickname($post['commload_author']) . '[/b] (' . date_fixed($post['commload_time']) . ')' . "\r\n" . $post['commload_text'] . '[/q]' . "\r\n" . '</textarea><br />';
      echo '<input type="submit" value="Цитировать" /></form></div><br />';
    } else {
      show_error('Ошибка! Выбранное вами сообщение для цитирования не существует!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы цитировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                Подготовка к редактированию                             ##
# ###########################################################################################
case 'edit':

  $config['newtitle'] = 'Редактирование сообщения';

  $pid = abs(intval($_GET['pid']));

  if (is_user()) {
    $querypost = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_id`=? AND `commload_author`=? LIMIT 1;", array($pid, $log));
    $post = $querypost -> fetch();

    if (!empty($post)) {
      if ($post['commload_time'] + 600 > SITETIME) {
        $post['commload_text'] = nosmiles($post['commload_text']);
        $post['commload_text'] = str_replace('<br />', "\r\n", $post['commload_text']);

        echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['commload_author']) . '</b> <small>(' . date_fixed($post['commload_time']) . ')</small><br /><br />';

        echo '<div class="form" id="form">';
        echo '<form action="down.php?act=editpost&amp;id=' . $post['commload_down'] . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo 'Редактирование сообщения:<br />';
        echo '<textarea cols="25" rows="5" name="msg" id="msg">' . $post['commload_text'] . '</textarea><br />';
        echo '<input type="submit" value="Редактировать" /></form></div><br />';
      } else {
        show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
      } 
    } else {
      show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                    Редактирование сообщения                            ##
# ###########################################################################################
case 'editpost':

  $uid = check($_GET['uid']);
  $pid = abs(intval($_GET['pid']));
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 1000) {
        $querypost = DB :: $dbh -> query("SELECT * FROM `commload` WHERE `commload_id`=? AND `commload_author`=? LIMIT 1;", array($pid, $log));
        $post = $querypost -> fetch();

        if (!empty($post)) {
          if ($post['commload_time'] + 600 > SITETIME) {
            $msg = no_br($msg);
            $msg = antimat($msg);
            $msg = smiles($msg);

            DB :: $dbh -> query("UPDATE `commload` SET `commload_text`=? WHERE `commload_id`=?", array($msg, $pid));

            $_SESSION['note'] = 'Сообщение успешно отредактировано!';
            header ("Location: down.php?act=comments&id=$id&start=$start&" . SID);
            exit;
          } else {
            show_error('Ошибка! Редактирование невозможно, прошло более 10 минут!!');
          } 
        } else {
          show_error('Ошибка! Сообщение удалено или вы не автор этого сообщения!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы редактировать сообщения, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=edit&amp;id=' . $id . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                                 Удаление комментариев                                  ##
# ###########################################################################################
case 'del':

  $uid = check($_GET['uid']);
  if (isset($_POST['del'])) {
    $del = intar($_POST['del']);
  } else {
    $del = 0;
  } 

  if (is_admin(array(101, 102, 103, 105))) {
    if ($uid == $_SESSION['token']) {
      if (!empty($del)) {
        $del = implode(',', $del);

        $delcomments = DB :: $dbh -> exec("DELETE FROM `commload` WHERE `commload_id` IN (" . $del . ") AND `commload_down`=" . $id . ";");
        DB :: $dbh -> query("UPDATE `downs` SET `downs_comments`=`downs_comments`-? WHERE `downs_id`=?;", array($delcomments, $id));

        $_SESSION['note'] = 'Выбранные комментарии успешно удалены!';
        header ("Location: down.php?act=comments&id=$id&start=$start&" . SID);
        exit;
      } else {
        show_error('Ошибка! Отстутствуют выбранные комментарии для удаления!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_error('Ошибка! Удалять комментарии могут только модераторы!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="down.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                             Переадресация на последнюю страницу                        ##
# ###########################################################################################
case 'end':

  $query = DB :: $dbh -> queryFetch("SELECT `downs_id`, `downs_comments` FROM `downs` WHERE `downs_id`=? LIMIT 1;", array($id));

  if (!empty($query)) {
    $end = floor(($query['downs_comments'] - 1) / $config['downcomm']) * $config['downcomm'];

    header ("Location: down.php?act=comments&id=$id&start=$end&" . SID);
    exit;
  } else {
    show_error('Ошибка! Данного файла не существует!');
  } 

  break;

default:
  header("location: index.php?" . SID);
  exit;
  endswitch;

  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?' . SID . '">Категории</a><br />';
  echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';

  include_once ('../themes/' . $config['themes'] . '/foot.php');

  ?>